      SUBROUTINE  SFTRN2(IFUNCT)
C     (SFTRN2)
C     EWM  SFTRN2:  'END' and 'IF' analysis
C     NHFB (24-Feb-85) - Add PROCEDURE (IF-STOP/RETURN) and extra
C                        cases in  PROCEDURE ('IF'  Analysis)  to
C                        catch subroutine exits.
C     (24-FEB-85)
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       ADDBUF,      ATPENO,      CLOGNX,      CNAMNX
C     EXTERNAL REFS       DOCYCL,      DOEXIT,      F4MVC,       FLOGRW
C     EXTERNAL REFS       GCALPR,      GIFNLG,      GLOGRW,      GOTOS2
C     EXTERNAL REFS       GRWFLG,      INSERT,      IOFUNC,      NCODE
C     EXTERNAL REFS       OPNCNT,      OSFLST,      OSFRFL,      SCANER
C     EXTERNAL REFS       SFTERR,      SFTRN4
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      LOGICAL             SCANER
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                CCPROG,      FND1,        FND2,        I
C     SETS                IFTYPE,      SFEND,       STRCT,       SWORD
C     SETS                TSTRCT,      TWORD,       TYPE
C
      INTEGER             CCPROG,      I,           IFTYPE,      IFUNCT
      INTEGER             STRCT,       TSTRCT,      TWORD,       TYPE
      LOGICAL             FND1,        FND2,        SFEND,       SWORD
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM01  /
C
      INTEGER             BYTE,        CC,          CCLABL
      INTEGER             CCMORE,      IN,          INDENT
      INTEGER             LLABL,       MLABL
      INTEGER             NHELD,       OUT
      INTEGER             UNDENT
      LOGICAL             EOF,         FIRST,       LABEL,       LAST
      LOGICAL             MORE
C
      COMMON / COM01  /   BYTE,        CC,          CCLABL
      COMMON / COM01  /   CCMORE,      EOF,         FIRST,       IN
      COMMON / COM01  /   INDENT,      LABEL,       LAST
      COMMON / COM01  /   LLABL,       MLABL,       MORE
      COMMON / COM01  /   NHELD
      COMMON / COM01  /   OUT,         UNDENT
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM02  /
C
      INTEGER             CCFLGS,      CCLIST,      CCNAME,      CCRW
      INTEGER             DEFNO,       INDEXS,      LFLGS,       LLIST
      INTEGER             LLOGS,       MAXLEV,      NEXT
C
      COMMON / COM02  /   CCFLGS(2),   CCLIST,      CCNAME,      CCRW
      COMMON / COM02  /   DEFNO,       INDEXS(38,39)
      COMMON / COM02  /   LFLGS(2),    LLIST,       LLOGS(2)
      COMMON / COM02  /   MAXLEV,      NEXT
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM03  /
C
      INTEGER             CASES,       CCINDX,      CCLOG,       CCLOGS
      INTEGER             LINDX,       LLOG
      INTEGER             MINDX,       NFND,        NONE
      INTEGER             NSTACK,      S1STAK,      SFNMBR
      LOGICAL             BLANK,       FOUND,       NOFLOW,      NONMBR
      LOGICAL             XLATED
C
      COMMON / COM03  /   BLANK,       CASES(39),   CCINDX,      CCLOG
      COMMON / COM03  /   CCLOGS(2),   FOUND,       LINDX
      COMMON / COM03  /   LLOG,        MINDX
      COMMON / COM03  /   NFND,        NOFLOW,      NONE,        NONMBR
      COMMON / COM03  /   NSTACK,      S1STAK(39),  SFNMBR
      COMMON / COM03  /   XLATED
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM05  /
C
      INTEGER             BLANKS,      LEFT,        LEVEL
      INTEGER             RIGHT,       S0,          S1,          STRCTS
      COMMON / COM05  /   BLANKS(92),  LEFT,        LEVEL
      COMMON / COM05  /   RIGHT,       S0,          S1
      COMMON / COM05  /   STRCTS(39)
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM06  /
C
      INTEGER             F4KEY,       HOLDIO,      INSF,        LINE
      INTEGER             LINENO,      MAXIN,       MDATA,       OUTERR
      INTEGER             OUTF4,       OUTSF,       P2BASE,      PBASE
      INTEGER             SBASE,       SFKEY,       SPACES,      TEMPF4
      LOGICAL             ERRORS
      COMMON / COM06  /   ERRORS,      F4KEY,       HOLDIO,      INSF
      COMMON / COM06  /   LINE,        LINENO,      MAXIN,       MDATA
      COMMON / COM06  /   OUTERR,      OUTF4,       OUTSF,       P2BASE
      COMMON / COM06  /   PBASE,       SBASE,       SFKEY,       SPACES
      COMMON / COM06  /   TEMPF4
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM07  /
C
      INTEGER             S1PNDG,      S2
      LOGICAL             EXITS,       FND,         OTHERS
C
      COMMON / COM07  /   EXITS(39),   FND,         OTHERS(39),  S1PNDG
      COMMON / COM07  /   S2
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM08  /
C
      LOGICAL             CYCLES
C
      COMMON / COM08  /   CYCLES(39)
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM10  /
C
      INTEGER             L0,          L1STAK,      LBASE
C
      COMMON / COM10  /   L0,          L1STAK(39),  LBASE
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM11  /
C
      INTEGER             COMCHR,      LCCHR
C
      COMMON / COM11  /   COMCHR(1),   LCCHR
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM16  /
C
      INTEGER             LINES
C
      COMMON / COM16  /   LINES(2,299)
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM17  /
C
      INTEGER             ERROUT,      F4OUT,       INPUT,       SFOUT
C
      COMMON / COM17  /   ERROUT,      F4OUT,       INPUT,       SFOUT
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM18  /
C
      LOGICAL             DEBUG,       NOSFL,       PRETTY
C
      COMMON / COM18  /   DEBUG,       NOSFL,       PRETTY
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM24  /
C
      INTEGER             FIND,        LOCATE,      SCAN
C
      COMMON / COM24  /   FIND,        LOCATE,      SCAN
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM25  /
C
      INTEGER             DEFINE,      DOCASE,      DOFOR,       DOWITH
      INTEGER             ELSEIF,      FOREVR,      IFELSE,      IFTHEN
      INTEGER             ONCE,        PROC,        UNTIL,       WHILE
C
      COMMON / COM25  /   DEFINE,      DOCASE,      DOFOR,       DOWITH
      COMMON / COM25  /   ELSEIF,      FOREVR,      IFELSE,      IFTHEN
      COMMON / COM25  /   ONCE,        PROC,        UNTIL,       WHILE
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM27  /
C
      INTEGER             LNAME,       LNAMES,      MAXTAB,      MNAMES
      INTEGER             NAMENO,      NAMTAB,      NNAMES,      USES
      INTEGER             DEFS
C
      COMMON / COM27  /   LNAME,       LNAMES(299), MAXTAB,      MNAMES
      COMMON / COM27  /   NAMENO,      NAMTAB(2099),NNAMES
      COMMON / COM27  /   USES(299),   DEFS(299)
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM30  /
C
      INTEGER             NB,          BUFFER
C
      COMMON / COM30  /   NB,          BUFFER(1326)
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM31  /
C
      INTEGER             NS,          NSMAX,       STMT
C
      COMMON / COM31  /   NS,          NSMAX,       STMT(1326)
C
C
      NX0003=IFUNCT
      IF (NX0003.LT.1.OR.NX0003.GT.2) GO TO 20003
      GO TO (20001,20002), NX0003
20001 ASSIGN 20005 TO NPR001
      GO TO 30001
20005 GO TO 20004
20002 ASSIGN 20006 TO NPR002
      GO TO 30002
20006 CONTINUE
20003 CONTINUE
C
20004 RETURN
C
C-----------------------------------------------------------------------
C---- PROCEDURE ('END' Analysis)
30001 IF (.NOT.( LEVEL .GT. 0)) GO TO 20007
      IF (.NOT.( MORE )) GO TO 20010
      ASSIGN 20013 TO NPR003
      GO TO 30003
20013 GO TO 20011
20010 SFEND=.TRUE.
      IF (.NOT.(PRETTY)) GO TO 20014
      ASSIGN 20017 TO NPR004
      GO TO 30004
20017 CONTINUE
20014 CONTINUE
20015 CONTINUE
20011 CONTINUE
20012 IF (.NOT.(SFEND)) GO TO 20018
      ASSIGN 20018 TO NPR005
      GO TO 30005
20018 GO TO 20008
20007 FND1=.NOT. MORE
      FND2=MORE
      IF (.NOT.(.NOT. FND1)) GO TO 20019
      CCPROG=CCMORE
      FND2=SCANER(FIND,7HPROGRAM,7)
20019 IF (.NOT.(LAST)) GO TO 20022
      IF (.NOT.(FND1.OR.FND2)) GO TO 20025
      ASSIGN 20028 TO NPR006
      GO TO 30006
20028 CONTINUE
20025 IF (.NOT.(PRETTY .AND. FND1)) GO TO 20029
      CALL INSERT (STMT,CCMORE+3,NS,8H PROGRAM,1,8)
      CCPROG = CCMORE + 4
      FND2 = .TRUE.
20029 ASSIGN 20032 TO NPR007
      GO TO 30007
20032 IF (FND2) CALL F4MVC(BLANKS,1,STMT,CCPROG,7)
      ASSIGN 20033 TO NPR008
      GO TO 30008
20033 XLATED=.TRUE.
      GO TO 20023
20022 IF (.NOT.(FND1)) GO TO 20034
      CALL SFTERR(1,24H(Extraneous END ignored))
      GO TO 20035
20034 ASSIGN 20037 TO NPR009
      GO TO 30009
20037 IF (SWORD) CALL SFTERR(1,
     X26H(Unmatched structured END))
20035 IF (FND2) CALL SFTERR(1,
     X44H(Program text follows program END statement))
20023 CONTINUE
20008 CONTINUE
20009 FOUND = .TRUE.
      GO TO 20005
C
C-----------------------------------------------------------------------
C---- PROCEDURE ('IF' Analysis)
30002 ASSIGN 20038 TO NPR010
      GO TO 30010
20038 IF (.NOT.(FND)) GO TO 20039
      FND=.FALSE.
      IFTYPE=0
      GO TO 20043
20042 IF (FND .OR. (IFTYPE .GE. 8)) GO TO 20044
20043 IFTYPE = IFTYPE + 1
      NX0053=IFTYPE
      IF (NX0053.LT.1.OR.NX0053.GT.8) GO TO 20053
      GO TO (20045,20046,20047,20048,20049,20050,20051,20052), NX0053
20045 IF (.NOT.(SCANER (FIND,4HTHEN,4))) GO TO 20055
      ASSIGN 20055 TO NPR011
      GO TO 30011
20055 GO TO 20054
20046 IF (.NOT.(SCANER (FIND,2HDO,2))) GO TO 20056
      ASSIGN 20056 TO NPR012
      GO TO 30012
20056 GO TO 20054
20047 IF (.NOT.(SCANER (FIND,4HEXIT,4))) GO TO 20057
      ASSIGN 20057 TO NPR013
      GO TO 30013
20057 GO TO 20054
20048 IF (.NOT.(SCANER (FIND,4HREAD,4))) GO TO 20058
      ASSIGN 20058 TO NPR014
      GO TO 30014
20058 GO TO 20054
20049 IF (.NOT.(SCANER (FIND,5HWRITE,5))) GO TO 20059
      ASSIGN 20059 TO NPR014
      GO TO 30014
20059 GO TO 20054
20050 IF (.NOT.(SCANER (FIND,5HCYCLE,5))) GO TO 20060
      ASSIGN 20060 TO NPR015
      GO TO 30015
20060 GO TO 20054
20051 IF (.NOT.(SCANER (FIND,6HRETURN,6))) GO TO 20061
      ASSIGN 20061 TO NPR016
      GO TO 30016
20061 GO TO 20054
20052 IF (.NOT.(SCANER (FIND,4HSTOP,4))) GO TO 20062
      ASSIGN 20062 TO NPR016
      GO TO 30016
20062 CONTINUE
20053 CONTINUE
20054 GO TO 20042
20044 GO TO 20040
20039 IF (.NOT.(SCANER(FIND,4HNONE,4))) GO TO 20063
      ASSIGN 20066 TO NPR017
      GO TO 30017
20066 GO TO 20064
20063 FND = SCANER(FIND,2HNO,2) .AND. SCANER(FIND,4HEXIT,
     X4)
      IF (FND) CALL SFTRN4(7)
20064 CONTINUE
20040 FOUND=.TRUE.
      GO TO 20006
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Attach Pending Number, If Any, To Generated Statement)
30018 CALL ATPENO
      GO TO 20140
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Check For '(LOGIC)' Next)
30010 CALL CLOGNX
      GO TO 20038
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Check For '(NAME)' Next)
30019 CALL CNAMNX
      GO TO 20141
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Check For S-Word After 'END')
30009 TWORD=0
      TYPE=0
      GO TO 20068
20067 IF (TWORD.NE.0 .OR. TYPE.EQ.14) GO TO 20069
20068 TYPE=TYPE+1
      NX0084=TYPE
      IF (NX0084.LT.1.OR.NX0084.GT.14) GO TO 20084
      GO TO (20070,20071,20072,20073,20074,20075,20076,20077,20078,20079
     X,20080,20081,20082,20083), NX0084
20070 IF (SCANER(FIND,2HIF,2)) TWORD=IFTHEN
      GO TO 20085
20071 IF (SCANER(FIND,5HWHILE,5)) TWORD=WHILE
      GO TO 20085
20072 IF (SCANER(FIND,9HPROCEDURE,9)) TWORD=PROC
      GO TO 20085
20073 IF (SCANER(FIND,4HPROC,4)) TWORD=PROC
      GO TO 20085
20074 IF (SCANER(FIND,7HFOREVER,7)) TWORD=FOREVR
      GO TO 20085
20075 IF (SCANER(FIND,3HFOR,3)) TWORD=DOFOR
      GO TO 20085
20076 IF (SCANER(FIND,4HWITH,4)) TWORD=DOWITH
      GO TO 20085
20077 IF (SCANER(FIND,5HUNTIL,5)) TWORD=UNTIL
      GO TO 20085
20078 IF (SCANER(FIND,4HCASE,4)) TWORD=DOCASE
      GO TO 20085
20079 IF (SCANER(FIND,4HONCE,4)) TWORD=ONCE
      GO TO 20085
20080 IF (SCANER(FIND,5HBLOCK,5)) TWORD=ONCE
      GO TO 20085
20081 IF (SCANER(FIND,10HDEFINITION,10)) TWORD=DEFINE
      GO TO 20085
20082 IF (SCANER(FIND,3HDEF,3)) TWORD=DEFINE
      GO TO 20085
20083 IF (.NOT.(SCANER(FIND,7HPROGRAM,7))) GO TO 20086
      CALL SFTERR(1,
     X40H(End of program encountered prematurely))
20086 CONTINUE
20084 CONTINUE
20085 GO TO 20067
20069 SWORD=TWORD.NE.0
      IF (MORE) SWORD = SWORD .AND. SCANER(FIND,COMCHR,LCCHR)
      GO TO NPR009, (20037,20238)
C
C-----------------------------------------------------------------------
C---- PROCEDURE (END of DEFINITION)
30020 SFNMBR=NONE
      ASSIGN 20089 TO NPR021
      GO TO 30021
20089 OUT=TEMPF4
      LINES(2,DEFNO)=NHELD
      GO TO 20233
C
C-----------------------------------------------------------------------
C---- PROCEDURE (END of DO-CASE)
30022 ASSIGN 20090 TO NPR021
      GO TO 30021
20090 S1=S1+CASES(LEVEL)+1
      IF (.NOT.(.NOT.OTHERS(LEVEL))) GO TO 20091
      ASSIGN 20094 TO NPR006
      GO TO 30006
20094 S1PNDG=S1
20091 ASSIGN 20095 TO NPR006
      GO TO 30006
20095 S1PNDG=S1+1
      GO TO 20230
C
C-----------------------------------------------------------------------
C---- PROCEDURE (END of DO-FOR)
30023 ASSIGN 20096 TO NPR021
      GO TO 30021
20096 IF (.NOT.(OTHERS(LEVEL))) GO TO 20097
      ASSIGN 20100 TO NPR006
      GO TO 30006
20100 S1PNDG=S1+1
      GO TO 20098
20097 S2=S1-2
      ASSIGN 20101 TO NPR024
      GO TO 30024
20101 ASSIGN 20102 TO NPR006
      GO TO 30006
20102 S1PNDG=S1
      IF (.NOT.(EXITS(LEVEL))) GO TO 20103
      ASSIGN 20106 TO NPR006
      GO TO 30006
20106 S1PNDG=S1+1
20103 CONTINUE
20098 GO TO 20227
C
C-----------------------------------------------------------------------
C---- PROCEDURE (END of DO-FOREVER)
30025 ASSIGN 20107 TO NPR021
      GO TO 30021
20107 S2=S1
      IF (.NOT.(.NOT.NOFLOW)) GO TO 20108
      ASSIGN 20108 TO NPR024
      GO TO 30024
20108 ASSIGN 20109 TO NPR006
      GO TO 30006
20109 S1PNDG=S1+1
      GO TO 20231
C
C-----------------------------------------------------------------------
C---- PROCEDURE (END of DO-ONCE)
30026 ASSIGN 20110 TO NPR021
      GO TO 30021
20110 IF (.NOT.(EXITS(LEVEL))) GO TO 20111
      ASSIGN 20114 TO NPR006
      GO TO 30006
20114 S1PNDG=S1
20111 GO TO 20232
C
C-----------------------------------------------------------------------
C---- PROCEDURE (END of DO-UNTIL)
30027 ASSIGN 20115 TO NPR021
      GO TO 30021
20115 S2=S1
      ASSIGN 20116 TO NPR024
      GO TO 30024
20116 ASSIGN 20117 TO NPR006
      GO TO 30006
20117 S1PNDG=S1+2
      GO TO 20229
C
C-----------------------------------------------------------------------
C---- PROCEDURE (END of DO-WHILE)
30028 ASSIGN 20118 TO NPR021
      GO TO 30021
20118 S2=S1
      ASSIGN 20119 TO NPR024
      GO TO 30024
20119 ASSIGN 20120 TO NPR006
      GO TO 30006
20120 S1PNDG=S1+1
      GO TO 20225
C
C-----------------------------------------------------------------------
C---- PROCEDURE (END of DO-WITH)
30029 ASSIGN 20121 TO NPR021
      GO TO 30021
20121 IF (.NOT.EXITS(LEVEL)) CALL SFTERR (1,
     X38H(DO-WITH structure has no WHILE/UNTIL))
      S2=S1-1
      ASSIGN 20122 TO NPR024
      GO TO 30024
20122 ASSIGN 20123 TO NPR006
      GO TO 30006
20123 S1PNDG=S1
      GO TO 20228
C
C-----------------------------------------------------------------------
C---- PROCEDURE (END of IF-THEN)
30030 ASSIGN 20124 TO NPR021
      GO TO 30021
20124 ASSIGN 20125 TO NPR006
      GO TO 30006
20125 IF (.NOT.(STRCT.EQ.ELSEIF)) GO TO 20126
      S1PNDG=L1STAK(LEVEL)
      ASSIGN 20129 TO NPR006
      GO TO 30006
20129 S1=S1+1
20126 S1PNDG=S1
      IF (.NOT.(EXITS(LEVEL))) GO TO 20130
      ASSIGN 20133 TO NPR006
      GO TO 30006
20133 S1PNDG=S1+1
20130 GO TO NPR030, (20223,20224,20234)
C
C-----------------------------------------------------------------------
C---- PROCEDURE (END of PROCEDURE)
30031 ASSIGN 20134 TO NPR021
      GO TO 30021
20134 IF (.NOT.(EXITS(LEVEL))) GO TO 20135
      ASSIGN 20138 TO NPR006
      GO TO 30006
20138 S1PNDG=S1
20135 NAMENO=S1-P2BASE
      ASSIGN 20139 TO NPR032
      GO TO 30032
20139 GO TO 20226
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Find 'LOGIC=FLAG' Field(s) in READ/WRITE)
30033 CALL FLOGRW
      GO TO 20166
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Generate 'GO TO NPRXXX')
30032 CALL ADDBUF (18H      GO TO NPR000,1,18)
      ASSIGN 20140 TO NPR018
      GO TO 30018
20140 CALL NCODE (BUFFER,16,18,NAMENO)
      CALL IOFUNC (F4OUT,BUFFER,NB)
      NB=0
      GO TO 20139
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Generate 'GO TO S2')
30024 CALL GOTOS2
      GO TO NPR024, (20101,20108,20116,20119,20122,20164)
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Generate 'S1 IF (.NOT.(LOGIC)) GO TO S2')
30034 CALL GIFNLG
      GO TO NPR034, (20146,20171,20183)
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Generate Call To Procedure)
30035 CALL GCALPR
      GO TO 20147
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Generate Logic-Setting For Read/Write)
30036 CALL GLOGRW
      GO TO 20173
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Generate Read/Write With Flag(S))
30037 CALL GRWFLG
      GO TO 20172
C
C-----------------------------------------------------------------------
C---- PROCEDURE (IF-CYCLE)
30015 CALL DOCYCL(2)
      FND=.TRUE.
      GO TO 20060
C
C-----------------------------------------------------------------------
C---- PROCEDURE (IF-DO)
30012 ASSIGN 20141 TO NPR019
      GO TO 30019
20141 IF (.NOT.(FND .AND. .NOT.MORE)) GO TO 20142
      ASSIGN 20145 TO NPR021
      GO TO 30021
20145 S1=0
      S2=S0+1
      ASSIGN 20146 TO NPR034
      GO TO 30034
20146 S1=S2
      ASSIGN 20147 TO NPR035
      GO TO 30035
20147 S0=S0+1
20142 FND=.TRUE.
      GO TO 20056
C
C-----------------------------------------------------------------------
C---- PROCEDURE (IF-EXIT)
30013 CALL DOEXIT(2)
      FND=.TRUE.
      GO TO 20057
C
C-----------------------------------------------------------------------
C---- PROCEDURE (IF-NONE)
30017 IF (.NOT.(.NOT.MORE)) GO TO 20148
      IF (.NOT.(LEVEL.GT.0)) GO TO 20151
      IF (.NOT.(STRCTS(LEVEL).EQ.DOCASE)) GO TO 20154
      IF (.NOT.(.NOT.OTHERS(LEVEL))) GO TO 20157
      S1=S1STAK(LEVEL)+CASES(LEVEL)+1
      INDENT=LEVEL-1
      ASSIGN 20160 TO NPR021
      GO TO 30021
20160 IF (.NOT.(.NOT.NOFLOW)) GO TO 20161
      S2=S1+1
      ASSIGN 20164 TO NPR024
      GO TO 30024
20164 CONTINUE
20161 CONTINUE
20162 ASSIGN 20165 TO NPR006
      GO TO 30006
20165 S1PNDG=S1
      OTHERS(LEVEL)=.TRUE.
      GO TO 20158
20157 CALL SFTERR (1,
     X26H(Multiple IF-NONE ignored))
20158 CONTINUE
20159 GO TO 20155
20154 CALL SFTERR (1,
     X38H(IF-NONE not within DO-CASE structure))
20155 GO TO 20152
20151 CALL SFTERR (1,26H(IF-NONE found at level 0))
20152 CONTINUE
20148 GO TO 20066
C
C-----------------------------------------------------------------------
C---- PROCEDURE (IF-READ/WRITE)
30014 ASSIGN 20166 TO NPR033
      GO TO 30033
20166 IF (.NOT.(NFND.GT.0)) GO TO 20167
      ASSIGN 20170 TO NPR021
      GO TO 30021
20170 S1=0
      S2=S0+NFND+1
      ASSIGN 20171 TO NPR034
      GO TO 30034
20171 ASSIGN 20172 TO NPR037
      GO TO 30037
20172 ASSIGN 20173 TO NPR036
      GO TO 30036
20173 S0=S0+NFND+1
20167 FND=.TRUE.
      GO TO NPR014, (20058,20059)
C
C-----------------------------------------------------------------------
C---- PROCEDURE (IF-STOP/RETURN)
30016 IF (.NOT.(.NOT.SCANER (LOCATE,1H=,1))) GO TO 20174
      UNDENT = 999
      ASSIGN 20177 TO NPR007
      GO TO 30007
20177 ASSIGN 20178 TO NPR008
      GO TO 30008
20178 XLATED = .TRUE.
      UNDENT = 0
20174 FND=.TRUE.
      GO TO NPR016, (20061,20062)
C
C-----------------------------------------------------------------------
C---- PROCEDURE (IF-THEN)
30011 IF (.NOT.(.NOT.MORE)) GO TO 20179
      ASSIGN 20182 TO NPR021
      GO TO 30021
20182 S1=0
      S2=S0+1
      ASSIGN 20183 TO NPR034
      GO TO 30034
20183 IF (LEVEL.GE.MAXLEV) CALL SFTERR (2,
     X28H(Too many levels of nesting))
      LEVEL=LEVEL+1
      STRCTS(LEVEL)=IFTHEN
      S1STAK(LEVEL)=S2
      S0=S0+3
20179 FND=.TRUE.
      GO TO 20055
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Insert Expected S-Word After END Keyword)
30004 NX0195=STRCTS(LEVEL)
      IF (NX0195.LT.1.OR.NX0195.GT.11) GO TO 20195
      GO TO (20184,20185,20186,20187,20188,20189,20190,20191,20192,20193
     X,20194), NX0195
20184 CALL INSERT (STMT,CCMORE+3,NS,3H IF,1,3)
      GO TO 20196
20185 CALL INSERT (STMT,CCMORE+3,NS,3H IF,1,3)
      GO TO 20196
20186 CALL INSERT (STMT,CCMORE+3,NS,6H WHILE,1,6)
      GO TO 20196
20187 CALL INSERT (STMT,CCMORE+3,NS,10H PROCEDURE,1,10)
      GO TO 20196
20188 CALL INSERT (STMT,CCMORE+3,NS,4H FOR,1,4)
      GO TO 20196
20189 CALL INSERT (STMT,CCMORE+3,NS,5H WITH,1,5)
      GO TO 20196
20190 CALL INSERT (STMT,CCMORE+3,NS,6H UNTIL,1,6)
      GO TO 20196
20191 CALL INSERT (STMT,CCMORE+3,NS,5H CASE,1,5)
      GO TO 20196
20192 CALL INSERT (STMT,CCMORE+3,NS,8H FOREVER,1,8)
      GO TO 20196
20193 CALL INSERT (STMT,CCMORE+3,NS,6H BLOCK,1,6)
      GO TO 20196
20194 CALL INSERT (STMT,CCMORE+3,NS,11H DEFINITION,1,11)
20195 CONTINUE
20196 GO TO 20017
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Output 'S1PNDG CONTINUE')
30006 CALL OPNCNT
      GO TO NPR006, (20028,20094,20095,20100,20102,20106,20109,20114,201
     X17,20120,20123,20125,20129,20133,20138,20165)
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Output SFTRAN Statement To List File)
30021 CALL OSFLST
      GO TO NPR021, (20089,20090,20096,20107,20110,20115,20118,20121,201
     X24,20134,20145,20160,20170,20182)
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Output Statement To FORTRAN File)
30008 CALL OSFRFL
      GO TO NPR008, (20033,20178)
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Output Statement To List File)
30007 IF (.NOT.NOSFL) CALL IOFUNC(SFOUT,STMT,NS)
      GO TO NPR007, (20032,20177)
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Search Structure Stack Upward For Type Matching S-Word)
30038 I=0
      GO TO 20198
20197 IF (TSTRCT.EQ.TWORD .OR. I.EQ.LEVEL) GO TO 20199
20198 NSTACK=LEVEL-I
      STRCT=STRCTS(NSTACK)
      FND = STRCT.EQ.IFTHEN .OR. STRCT.EQ.IFELSE .OR.
     XSTRCT.EQ.ELSEIF
      IF (.NOT.(FND)) GO TO 20200
      TSTRCT=IFTHEN
      GO TO 20201
20200 TSTRCT=STRCT
20201 I=I+1
      GO TO 20197
C
20199 IF (.NOT.(.NOT. (TSTRCT.EQ.TWORD .AND. I.EQ.1))) GO TO 20203
      CALL SFTERR(1,
     X40H(END-type does not match structure-type))
      IF (.NOT.(TSTRCT.EQ.TWORD .AND. I.GT.1)) GO TO 20206
      LEVEL=NSTACK
      CALL SFTERR(1,67H(END statement was applied to nearest structure o
     Xf designated type))
      GO TO 20207
20206 CALL SFTERR(1,48H(END statement was applied to current structure))
20207 CONTINUE
20203 GO TO 20242
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Process End of a Structure)
30005 INDENT = LEVEL-1
      STRCT = STRCTS(LEVEL)
      S1 = S1STAK(LEVEL)
      NX0221= STRCT
      IF (NX0221.LT.1.OR.NX0221.GT.12 ) GO TO 20221
      GO TO (20209,20210,20211,20212,20213,20214,20215,20216,20217,20218
     X,20219,20220), NX0221
20209 ASSIGN 20223 TO NPR030
      GO TO 30030
20223 GO TO 20222
20210 ASSIGN 20224 TO NPR030
      GO TO 30030
20224 GO TO 20222
20211 ASSIGN 20225 TO NPR028
      GO TO 30028
20225 GO TO 20222
20212 ASSIGN 20226 TO NPR031
      GO TO 30031
20226 GO TO 20222
20213 ASSIGN 20227 TO NPR023
      GO TO 30023
20227 GO TO 20222
20214 ASSIGN 20228 TO NPR029
      GO TO 30029
20228 GO TO 20222
20215 ASSIGN 20229 TO NPR027
      GO TO 30027
20229 GO TO 20222
20216 ASSIGN 20230 TO NPR022
      GO TO 30022
20230 GO TO 20222
20217 ASSIGN 20231 TO NPR025
      GO TO 30025
20231 GO TO 20222
20218 ASSIGN 20232 TO NPR026
      GO TO 30026
20232 GO TO 20222
20219 ASSIGN 20233 TO NPR020
      GO TO 30020
20233 GO TO 20222
20220 ASSIGN 20234 TO NPR030
      GO TO 30030
20234 CONTINUE
20221 CONTINUE
C
C          (12-MAR-83) Clear LEVEL-dependent stacks; this was not
C                      done previously,  and  resulted  in  later
C                      references to these arrays after LEVEL had
C                      again  been  incremented.   This  is  turn
C                      caused  statement   labels  and   CONTINUE
C                      statements  to  be  generated  which  were
C                      never referenced.
C
20222 STRCTS(LEVEL) = 0
      S1STAK(LEVEL) = 0
      CASES(LEVEL) = 0
      OTHERS(LEVEL) = .FALSE.
      EXITS(LEVEL) = .FALSE.
      CYCLES(LEVEL) = .FALSE.
      LEVEL = LEVEL-1
      GO TO 20018
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Test Chars Following 'END')
30003 IF (.NOT.(SCANER(FIND,COMCHR,LCCHR))) GO TO 20235
      SFEND=.TRUE.
      GO TO 20236
20235 ASSIGN 20238 TO NPR009
      GO TO 30009
20238 SFEND=SWORD
      IF (.NOT.(SFEND)) GO TO 20239
      ASSIGN 20242 TO NPR038
      GO TO 30038
20242 CONTINUE
20239 CONTINUE
20236 GO TO 20013
C
      END
