#include "p79.h"

/* Return the current working directory name */

void
FORTRAN(p79cwd,P79CWD)(cwd, FLENARG(cwd))
FCHAR		cwd;
int		FLENARG(cwd);
{
    int		n;
    char	*p;

#if __host_mips && defined(SYSTYPE_BSD43) && defined(_MIPSEB)
    /* MIPS RISCos and EP/IX have getwd() in Berkeley environment (needed 
       for PLOT79 network support), and getcwd() in System V environment. */
    p = (char*)malloc(FLEN(cwd));
    if (p)
	p = (char*)getwd(p);
#else
    p = (char*)getcwd((char*)NULL,FLEN(cwd));
#endif
    if (p)
    {
	n = strlen(p);
	(void)memcpy(&CH(cwd,0),p,n);
	(void)memset(&CH(cwd,n),' ',FLEN(cwd) - n);
	(void)free(p);
    }
    else
	(void)memset(&CH(cwd,0),' ',FLEN(cwd));
}
