      SUBROUTINE  GCALPR
C     (GCALPR)
C     PROCEDURE (Generate CALL to PROCEDURE)
C     (24-OCT-84)
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       ADDBUF,      ATPENO,      GNAMNO,      GOTOS2
C     EXTERNAL REFS       IOFUNC,      NCODE,       OPNCNT,      SFTERR
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM05  /
C
      INTEGER             BLANKS,      LEFT,        LEVEL
      INTEGER             RIGHT,       S0,          S1,          STRCTS
      COMMON / COM05  /   BLANKS(92),  LEFT,        LEVEL
      COMMON / COM05  /   RIGHT,       S0,          S1
      COMMON / COM05  /   STRCTS(39)
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM06  /
C
      INTEGER             F4KEY,       HOLDIO,      INSF,        LINE
      INTEGER             LINENO,      MAXIN,       MDATA,       OUTERR
      INTEGER             OUTF4,       OUTSF,       P2BASE,      PBASE
      INTEGER             SBASE,       SFKEY,       SPACES,      TEMPF4
      LOGICAL             ERRORS
      COMMON / COM06  /   ERRORS,      F4KEY,       HOLDIO,      INSF
      COMMON / COM06  /   LINE,        LINENO,      MAXIN,       MDATA
      COMMON / COM06  /   OUTERR,      OUTF4,       OUTSF,       P2BASE
      COMMON / COM06  /   PBASE,       SBASE,       SFKEY,       SPACES
      COMMON / COM06  /   TEMPF4
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM07  /
C
      INTEGER             S1PNDG,      S2
      LOGICAL             EXITS,       FND,         OTHERS
C
      COMMON / COM07  /   EXITS(39),   FND,         OTHERS(39),  S1PNDG
      COMMON / COM07  /   S2
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM17  /
C
      INTEGER             ERROUT,      F4OUT,       INPUT,       SFOUT
C
      COMMON / COM17  /   ERROUT,      F4OUT,       INPUT,       SFOUT
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM25  /
C
      INTEGER             DEFINE,      DOCASE,      DOFOR,       DOWITH
      INTEGER             ELSEIF,      FOREVR,      IFELSE,      IFTHEN
      INTEGER             ONCE,        PROC,        UNTIL,       WHILE
C
      COMMON / COM25  /   DEFINE,      DOCASE,      DOFOR,       DOWITH
      COMMON / COM25  /   ELSEIF,      FOREVR,      IFELSE,      IFTHEN
      COMMON / COM25  /   ONCE,        PROC,        UNTIL,       WHILE
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM27  /
C
      INTEGER             LNAME,       LNAMES,      MAXTAB,      MNAMES
      INTEGER             NAMENO,      NAMTAB,      NNAMES,      USES
      INTEGER             DEFS
C
      COMMON / COM27  /   LNAME,       LNAMES(299), MAXTAB,      MNAMES
      COMMON / COM27  /   NAMENO,      NAMTAB(2099),NNAMES
      COMMON / COM27  /   USES(299),   DEFS(299)
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM28  /
C
      INTEGER             MCALLS,      NCALLS,      NAMNOS,      SCALLS
C
      COMMON / COM28  /   MCALLS,      NCALLS,      NAMNOS(599)
      COMMON / COM28  /   SCALLS(599)
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM30  /
C
      INTEGER             NB,          BUFFER
C
      COMMON / COM30  /   NB,          BUFFER(1326)
C
C
      ASSIGN 20001 TO NPR001
      GO TO 30001
20001 ASSIGN 20002 TO NPR002
      GO TO 30002
20002 S2=PBASE+NAMENO
      ASSIGN 20003 TO NPR003
      GO TO 30003
20003 ASSIGN 20004 TO NPR004
      GO TO 30004
20004 S1PNDG=S1
      IF (DEFS(NAMENO) .EQ. DEFINE) CALL SFTERR (1,
     X33H(Name already used in definition))
      IF (USES(NAMENO) .EQ. DEFINE) CALL SFTERR (1,
     X30H(Name already used by INCLUDE))
      USES(NAMENO)=PROC
      IF (.NOT.(NCALLS .GE. MCALLS)) GO TO 20005
      CALL SFTERR (2,24H(Too many DO-PROCEDURES))
      GO TO 20006
20005 NCALLS=NCALLS+1
      SCALLS(NCALLS)=S1
      NAMNOS(NCALLS)=NAMENO
20006 CONTINUE
C
20007 RETURN
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Attach Pending Number, if any, to Generated Statement)
30005 CALL ATPENO
      GO TO 20008
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Generate 'ASSIGN S1 TO NPRXXX')
30002 CALL ADDBUF (28H      ASSIGN       TO NPR000,1,28)
      ASSIGN 20008 TO NPR005
      GO TO 30005
20008 CALL NCODE (BUFFER,14,18,S1)
      CALL NCODE (BUFFER,26,28,NAMENO)
      CALL IOFUNC (F4OUT,BUFFER,NB)
      NB=0
      GO TO 20002
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Generate 'GO TO S2')
30003 CALL GOTOS2
      GO TO 20003
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Get PROCEDURE/DEFINITION Name Number)
30001 CALL GNAMNO
      GO TO 20001
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Output 'S1PNDG CONTINUE')
30004 CALL OPNCNT
      GO TO 20004
C
      END
