      SUBROUTINE  READRC (IOUNIT,EOFILE,LINE,NWORDS,WORD1,WORD2)
C     (Read Record)
C     Retrieve "NWORDS"  words of  text  in "LINE(*)"  from  unit
C     number "IOUNIT".  "EOFILE" is set .TRUE. if an  end-of-file
C     occurs.  Integer "WORD1" and "WORD2" are also retrieved  as
C     part of the record.
C
C     This simple  operation is  relegated  to a  subroutine  for
C     three reasons:
C     1) an implied DO can be avoided on the READ statement,
C        which is usually more efficient.
C     2) word-size dependence for the FORMAT is localized.
C     3) replacement by an assembly-language equivalent is
C        facilitated.
C     (02-JUL-79)
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       READUA
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                EOFILE,      NWORDS,      WORD1,       WORD2
C
      INTEGER             IOUNIT,      LINE(1),     NWORDS,      WORD1
      INTEGER             WORD2
      LOGICAL             EOFILE
C
      READ (IOUNIT,END=20001) NWORDS,WORD1,WORD2
      EOFILE=.FALSE.
      GO TO 20002
20001 EOFILE=.TRUE.
20002 IF (.NOT.EOFILE) CALL READUA (IOUNIT,EOFILE,LINE,NWORDS)
C
      RETURN
      END
